#include "all.h"
void backup_faultstates(void)
{ 
  int i,k;

  // fprintf(resultsout,"faultlist:\n");
  for(i=1;i<=faultcnt;i++)
    {
      faultlist[i]->tmp_flag = faultlist[i]->flag;
      for(k=0;k<num_dff;k++)
	{	
	  (faultlist[i]->tmp_state)[k] = (faultlist[i]->state)[k];
	}   
      // fprintf(resultsout,"%d %d %d\n",get_from(i),get_to(i),get_sa(i));
    }
  for(k=0;k<num_dff;k++)
    {	
      tmpgoodstate[k] = goodstate[k]; 
    }     
} 
void restore_faultstates(void)
{ 
  int i,k;

  // fprintf(resultsout,"faultlist:\n");
  for(i=1;i<=faultcnt;i++)
    {
      faultlist[i]->flag =  faultlist[i]->tmp_flag;
      for(k=0;k<num_dff;k++)
	{	
	  (faultlist[i]->state)[k] = (faultlist[i]->tmp_state)[k];
	}   
      // fprintf(resultsout,"%d %d %d\n",get_from(i),get_to(i),get_sa(i));
    }
  for(k=0;k<num_dff;k++)
    {	
      goodstate[k] = tmpgoodstate[k]; 
    }     
} 

/*Omission-based compaction*/

int oms_compaction(int *vec_array, int numvec, int numbits)
{
  int tested_orig=0, tested_new=0, total_removed;
  int i, j, tmp_rmv=0, start_v=0, already_t = 0;
  FILE *vecfile;
  int eachstep=10;

  elapsetime_s(resultsout,TIME_OMS_CMPCT,false);

  if(numvec > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-compaction()\n", 
	      numvec, tmpvecsize); 
      // resize_tmpvec(tmpvecsize, numvec, numbits);
      exit(0);
    }

  backup_faultstates();
  total_removed = 0; 
  for(i=0;i<numvec;i++)
    {
      removed[i] = 0;
    }
  if(sfsimdebug && 0) fprintf(resultsout, "numvec=%d  numbits=%d\n",numvec, numbits);
  tested_orig = sfsim ("compaction.vectors", vec_array, numbits, numvec,
		       USEARRAY, resultsout, circuit, faultlist,
		       UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
		       NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
		       0, NEARLY_STOP);  
  printf("Number of initial vectors: %d, Number of faults detected: %d-compaction\n",
	 numvec, tested_orig); 
  if(tested_orig == 0)// this will bypass the compaction process.....J.Zhang
    {
      for(i=0;i<numvec;i++)
	{
	  removed[i] = 1;
	}
      total_removed = numvec;
    }
  else 
    {
      tmp_rmv = 0;
      for(j=0;j<1;j++)  // two iterations 
	{
	  start_v = 0;
	  already_t = 0;
	  for(i=0;i<numvec;i++)
	    {
	      if(i%eachstep == 0 && j == 0) // to speed up 
		{
		  already_t += sfsim ("compaction.vectors", vec_array, numbits, 
				      i-start_v-tmp_rmv,
				      USEARRAY, resultsout, circuit, faultlist,
				      UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
				      UPDATE_STATE, UPDATE_FAULT, UNINITIAL_FAULT, true,
				      start_v, NEARLY_STOP);
		  total_removed += tmp_rmv;
		  tmp_rmv = 0; 
		  start_v = i;
		}
	      if(removed[i] == 0)
		{ 
		  removed[i] = 1;
		  tested_new = sfsim ("compaction.vectors", vec_array, numbits, 
				      numvec-start_v-tmp_rmv-1,
				      USEARRAY, resultsout, circuit, faultlist,
				      UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
				      NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
				      start_v, EARLY_STOP);
		  printf("Vec#%d---tested_orig:%d---tested_new:%d\n",i,
			 tested_orig,tested_new+already_t);
		  
		  if(tested_new+already_t < tested_orig) removed[i] = 0;
		  else if(tested_new+already_t > tested_orig) 
		    {
		      tested_orig = tested_new+already_t;
		      tmp_rmv ++;
		      // total_removed++;
		    }
		  else tmp_rmv ++; // total_removed++;
		}
	    }
	  if(j==0) 
	    {
	      total_removed += tmp_rmv;
	      tmp_rmv = total_removed;
	      restore_faultstates();
	    }
	  else total_removed = tmp_rmv;
	}
    }
  printf("Number of compacted vectors: %d, Number of faults detected: %d-compaction\n",
	 numvec-total_removed, tested_orig); 
  
  /*write the compacted vectors in the file "compacted.vectors" */
  vecfile = fopen("compacted.vectors","w");
  for(i = 0;i<numvec; i++)
    {
      if(removed[i]==false)
	{
	  for(j = 0;j<numbits; j++)
	    {
	      fprintf(vecfile, "%c", vec_array[i*numbits+j]);
	    }
	  fprintf(vecfile,"\n");
	}
    }
  fclose(vecfile);

  restore_faultstates();

  elapsetime_e(resultsout,TIME_OMS_CMPCT,false);

  return(total_removed);
}

/*Restoration-based compaction*/

int rst_compaction(int *vec_array, int numvec, int numbits /*, int options*/)
     /*
       options: 
       1-following the order faults being detected, reverse restoration;
       2-following the reversed order of faults being detected, reverse restoration;
       3-following the order faults being detected, forward restoration;
     */
{
  int tested_orig=0, tested_new=0, total_restored;
  int i, j, vec, mark_tested=0, k=0, next=0;
  int *lastdflist;
  FILE *vecfile;

  elapsetime_s(resultsout,TIME_RST_CMPCT,false);

  if(numvec > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-rst_compaction()\n", 
	      numvec, tmpvecsize); 
      // resize_tmpvec(tmpvecsize, numvec, numbits);
      exit(0);
    }

  if(sfsimdebug && 0) fprintf(resultsout, "numvec=%d  numbits=%d\n",numvec, numbits);
  tested_orig = sfsim ("compaction.vectors", vec_array, numbits, numvec,
		       USEARRAY, resultsout, circuit, faultlist,
		       UNDETECTEDF, sfsimdebug, CREAT_FLIST, 0,
		       NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
		       0, NEARLY_STOP);  
  printf("# initial vectors: %d, # faults detected: %d-rst_compaction\n",
	 numvec, tested_orig); 
  //printf("DFFs' are initialized at vector#: %d-rst_compaction\n",initial_stt_vec); 

  /*  if(initial_stt_vec == 0)
    {
      printf("DFFs' are initialized at vector#: %d -- WRONG!!!-rst_compaction\n"
	     ,initial_stt_vec);
      return(-1);
    }
  */
  total_restored = 0; //initial_stt_vec; 
  for(i=0;i<numvec;i++)
    {
      removed[i] = 1;
      // if(i<initial_stt_vec) removed[i] = 0;
    }
  if(tested_orig == 0)// this will bypass the compaction process.....J.Zhang
    {
      total_restored = 0;
    }
  else 
    {
      for(i=0;i<1;i++)
	{
	  vec = numvec;
	  for(j= (int) detectedflist[0]; j >= 1; j--)
	    {
	      if(detectedflist[j][0] != 0)
		{
		  /* if(vec >= j)// && vec > initial_stt_vec) 
		     {
		     vec = j;
		     removed[vec-1] = 0;
		     total_restored ++;
		     vec --;	
		     }
		  */
		  for(k=j-1;k>0&&detectedflist[k][0] == 0;k--) ; //search for next flist
		  next = k;
		  while(( (tested_new =
			   sfsim ("compaction.vectors", vec_array, numbits, total_restored,
				  USEARRAY, resultsout, circuit, faultlist,
				  UNDETECTEDF, sfsimdebug, SIM_FLIST, j,
				  NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
				  0, NEARLY_STOP))
			  != detectedflist[j][0]) && (vec > 0)) //initial_stt_vec) )
		    {
		      /* printf( "fl[%d]--#flts in list=%d--#detected=%d--vec#=%d--#Restore=%d\n",
			 j, detectedflist[j][0],tested_new, vec, total_restored);
		      */ 
		      if(vec > j) vec = j;
		      for(k=0;(k<3)&&(vec>0);k++) //restore 3 when set==0;
			{		 
			  if(removed[vec-1] != 0)
			    {
			      removed[vec-1] = 0;
			      total_restored ++;
			    }
			  vec --;
			  if(vec<next) k=3;
			}	
		    }//while
		}//if(detectedflist...
	      // Please add some print statements here!!
	    }//for(j=...
	}//for(i=0...
    }//else
  
  //printf("restored_old=%d\n",total_restored);
  if(1)
    {
      lastdflist = detectedflist[numvec];
      detectedflist[numvec]=alldflist;
      mark_tested = sfsim ("compaction.vectors", vec_array, numbits, total_restored,
			   USEARRAY, resultsout, circuit, faultlist,
			   UNDETECTEDF, sfsimdebug, SIM_FLIST, numvec,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
			   0, NEARLY_STOP);
      for(k=1;k<=numvec;k++)
	{
	  if(removed[k-1] == 0)
	    {
	      removed[k-1] = 1;
	      tested_new =
		   sfsim ("compaction.vectors", vec_array, numbits, total_restored-1,
			  USEARRAY, resultsout, circuit, faultlist,
			  UNDETECTEDF, sfsimdebug, SIM_FLIST, numvec,
			  NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
			  0, NEARLY_STOP);
	      if( tested_new < mark_tested)
		removed[k-1] = 0;
	      else
		{
		  //printf("tested_new=%d,>=  mark_tested=%d\n", tested_new, mark_tested);
		  total_restored --;
		}
	    }
	}
      detectedflist[numvec]=lastdflist;
    }
  //printf("restored_new=%d\n",total_restored);
  tested_new = sfsim ("compaction.vectors", vec_array, numbits, total_restored,
		      USEARRAY, resultsout, circuit, faultlist,
		      UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
		      NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
		      0, NEARLY_STOP);
  printf("# compacted vectors: %d, # faults detected: %d-rst_compaction\n",
	 total_restored, tested_new); 
  
  /*write the compacted vectors in the file "compacted.vectors" */
  if(0) 
    {
      vecfile = fopen("compacted.vectors","w");
      for(i = 0;i<numvec; i++)
	{
	  if(removed[i]==false)
	    {
	      for(j = 0;j<numbits; j++)
		{     
		  fprintf(vecfile, "%c", vec_array[i*numbits+j]);
		}
	      fprintf(vecfile,"\n");
	    }
	}
      fclose(vecfile);
    }

  compact = 0;

  elapsetime_e(resultsout,TIME_RST_CMPCT,false);

  return(numvec-total_restored);
}

/*Restoration-based compaction*/

int rst_compaction1(int *vec_array, int numvec, int numbits /*, int options*/)
     /*
       options: 
       1-following the order faults being detected, reverse restoration;
       2-following the reversed order of faults being detected, reverse restoration;
       3-following the order faults being detected, forward restoration;
     */
{
  int tested_orig=0, tested_new=0, total_restored;
  int i, j, mark1=0, mark2=0, set=0, vec, k, mark_tested=0, kk;
  //FILE *vecfile;

  elapsetime_s(resultsout,TIME_RST_CMPCT,false);

  if(numvec > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-rst_compaction1()\n", 
	      numvec, tmpvecsize); 
      // resize_tmpvec(tmpvecsize, numvec, numbits);
      exit(0);
    }

  if(sfsimdebug && 0) fprintf(resultsout, "numvec=%d  numbits=%d\n",numvec, numbits);
  tested_orig = sfsim ("compaction.vectors", vec_array, numbits, numvec,
		       USEARRAY, resultsout, circuit, faultlist,
		       UNDETECTEDF, sfsimdebug, CREAT_FLIST, 0,
		       NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
		       0, NEARLY_STOP);  
  printf("Number of initial vectors: %d, Number of faults detected: %d-rst_compaction\n",
	 numvec, tested_orig); 
  printf("DFFs' are initialized at vector#: %d-rst_compaction1\n",initial_stt_vec); 

  /*  if(initial_stt_vec == 0)
    {
      printf("DFFs' are initialized at vector#: %d -- WRONG!!!-guo_compaction\n"
	     ,initial_stt_vec);
      return(-1);
    }
  */
  total_restored = 0; //initial_stt_vec; 
  for(i=0;i<numvec;i++)
    {
      removed[i] = 1;
      // if(i<initial_stt_vec) removed[i] = 0;
    }
  if(tested_orig == 0)// this will bypass the compaction process.....J.Zhang
    {
      total_restored = 0;
    }
  else 
    {
      /* restore..... */
      for(i=0;i<1;i++)
	{
	  vec = numvec;
	  mark1 = (int) detectedflist[0];	
	  printf("j=%d\n",mark1);  
	  for(j= (int) detectedflist[0]; j >= 1; j--)
	    {
	      if(detectedflist[j][0] != 0)
		{
		  /* if(vec >= j)// && vec > initial_stt_vec) 
		     {
		     vec = j;
		     removed[vec-1] = 0;
		     total_restored ++;
		     vec --;	
		     }
		  */

		  if(vec > j) 
		    {
		      vec = j;
		      mark1 = vec;
		    }
		  else
		    mark1 = vec; /*mark1: the initial vector to be restored*/
		  set = 0;
		  
		  while(( (tested_new =
			   sfsim ("compaction.vectors", vec_array, numbits, total_restored,
				  USEARRAY, resultsout, circuit, faultlist,
				  UNDETECTEDF, sfsimdebug, SIM_FLIST, j,
				  NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
				  0, NEARLY_STOP))
			  != detectedflist[j][0]) && (vec > 0)) //initial_stt_vec) )
		    {
		      /* printf( "fl[%d]--#flts in list=%d--#detected=%d--vec#=%d--#Restore=%d\n",
			 j, detectedflist[j][0],tested_new, vec, total_restored);
		      */ 
		      if(set == 1)
			{
			  if(removed[vec-1] != 0)
			    {
			      removed[vec-1] = 0;
			      total_restored ++;
			    }
			  vec --;
			}

		      for(kk=0;(kk<3)&&(set==0)&&(vec>0);kk++) //restore 3 when set==0;
			{
			  printf("j=%d,vec=%d\n",j,vec);
			  if((vec!=j)&&(detectedflist[vec][0] != 0) && (set == 0)) 
			    {
			      set = 1;
			      mark2 = vec;
			    }
			  if(removed[vec-1] != 0)
			    {
			      removed[vec-1] = 0;
			      total_restored ++;
			    }
			  vec --;
			}	
		      printf("restoring to vec=%d, set=%d, mark2=%d\n", vec, set, mark2);
		    }//while

		  mark_tested = tested_new;
		  if(set == 0)
		    mark2 = vec+1; //mark2: the last vector restored 

		  printf("mark1=%d;mark2=%d\n", mark1, mark2);
		  for(k=mark2+1;k<mark1;k++)
		    {
		      if(removed[k-1] == 0)
			{
			  removed[k-1] = 1;
			  
			  if( (tested_new =
			       sfsim ("compaction.vectors", vec_array, numbits, total_restored-1,
				      USEARRAY, resultsout, circuit, faultlist,
				      UNDETECTEDF, sfsimdebug, SIM_FLIST, j,
				      NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
				      0, NEARLY_STOP))
			      < mark_tested)
			    removed[k-1] = 0;
			  else
			    total_restored --;
			}
		      printf("omt to k=%d\n", k);
		    }//for(k=mark2....

		}//if(detectedflist...
	      // Please add some print statements here!!
	    }//for(j=...
	}//for(i=0...
    }//else
  
  tested_new = sfsim ("compaction.vectors", vec_array, numbits, total_restored,
		      USEARRAY, resultsout, circuit, faultlist,
		      UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
		      NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, true,
		      0, NEARLY_STOP);
  printf("Number of compacted vectors: %d, Number of faults detected: %d-rst_compaction\n",
	 total_restored, tested_new); 
  
  compact = 0;

  elapsetime_e(resultsout,TIME_RST_CMPCT,false);

  return(numvec-total_restored);
}

