char fix_optarg [MAXSTRSIZE];
int fix_optind = 0;
int largc = -1;
int largvptr;
int largvindex = 0;

/* This routine does not recognize options unless they are separate and
   preceeded by a - */
int fix_getopt (int argc, char *argv[], char * optstring)
{ /*  fix_getopt */
  extern int largc;
  extern int largvptr;
  char c;
  int i, j, k;
  char * local_p;

  if (largc == -1)
    {
      largc = argc;
      largvptr = 1;
    }
  
  while (largc > 1) /* If we are still within argument range */
    {
/*      printf ("Checking that argv [%d] not NULL.\n", largvptr); */
      if (argv [largvptr] != NULL) /* If argv is not null */
	{
/*	  printf ("Checking that argv [%d] not empty.\n", largvptr); */
	  if (argv [largvptr] [largvindex] != '\000') /* If argument is
							 not empty */
	    {
	      c = argv [largvptr] [largvindex];
	      local_p = argv [largvptr];
/*	      printf ("Checking that %c not blank.\n", c); */
	      while (local_p [largvindex] == ' ')
		{
		  ++ largvindex;
		  if (local_p [largvindex] == '\000')
		    {
		      ++ largvptr;
		      -- largc;
		      largvindex = 0;
		      local_p = argv [largvptr];
		      /* If option not there, return */
		      if (largc == 1) return (EOF);
		    }
		}
	      c = argv [largvptr] [largvindex];
/*	      printf ("Checking that %c is an option.\n", c); */
	      if (c == '-') /* Found an option */
		{
		  ++ largvindex;
		  local_p = argv [largvptr];
		  c = local_p [largvindex];
		  ++ largvindex;
		  k = strlength (optstring);
		  for (j = 0; j < k; ++ j)
		    {
		      if (optstring [j] == c) /* Legal option */
			{
			  if (optstring [j + 1] == ':') /* Has an argument */
			    {
			      /* Skip to next arg if needed */
			      if (local_p [largvindex] == '\000')
				{
				  ++ largvptr;
				  -- largc;
				  largvindex = 0;
				  local_p = argv [largvptr];
				  /* If option not there, return */
				  if (largc == 1) return (EOF);
				}
			      /* Throw away blank space and skip to next
				 argument if needed */
			      while (local_p [largvindex] == ' ')
				{
				  ++ largvindex;
				  if (local_p [largvindex] == '\000')
				    {
				      ++ largvptr;
				      -- largc;
				      largvindex = 0;
				      local_p = argv [largvptr];
				      /* If option not there, return */
				      if (largc == 1) return (EOF);
				    }
				}
			      i = 0;
			      for (k = largvindex;
				   ((local_p [k] != ' ')
				    && (local_p [k] != '\000'));)
				{
				  fix_optarg [i] = local_p [k];
				  ++ i; 
				  ++ k; 
				}
			      fix_optarg [i] = '\000';
			      /* Argument was successfully copied over */
			      largvindex = k;
			      
			      /* Skip to next arg if needed */
			      if (local_p [largvindex] == '\000')
				{
				  ++ largvptr;
				  -- largc;
				  largvindex = 0;
				  if (largc > 1)
				    local_p = argv [largvptr];
				}
			      /* Throw away blank space and skip to next
				 argument if needed */
			      if (largc > 1)
				while (local_p [largvindex] == ' ')
				  {
				    ++ largvindex;
				    if (local_p [largvindex] == '\000')
				      {
					++ largvptr;
					-- largc;
					largvindex = 0;
					local_p = argv [largvptr];
				      }
				  }
			    }
			  return (c); /* Return the option */
			}

		    } /* Close loop that searches for legal options */
		  printf ("Illegal option: %c\n", c);
		  return ('?');
		} /* Close conditional that demands - in front of options */
	      else
		{
		  ++ largvindex; /* Eliminate infinite loop in argument
				    parser */
/*		  printf ("Illegal option argument.\n"); */
		}
	    } /* Close condition of looking for non-empty argv */
	  else
	    { /* Bump to the next argv pointer */
	      ++ largvptr;
	      -- largc;
	      largvindex = 0;
	      /* If option not there, return */
	      if (largc == 1) return (EOF);
	      /* Throw away blank space and skip to next
		 argument if needed */
	      local_p = argv [largvptr];
	      while (local_p [largvindex] == ' ')
		{
		  ++ largvindex;
		  if (local_p [largvindex] == '\000')
		    {
		      ++ largvptr;
		      -- largc;
		      largvindex = 0;
		      local_p = argv [largvptr];
		      /* If option not there, return */
		      if (largc == 1) return (EOF);
		    }
		}
	    } /* Close condition that argv must not point to null char */
	} /* If argv is not null */
      else return (EOF);
    } /* Close condition that we still have a positive argument count */
  return (EOF); /* Out of arguments */

} /* fix_getopt */

/***************************************************************************/
/***************************************************************************/
char * fix_getsubsarg (int argc, char *argv[], char * sec_optarg)
{ /* fix_getsubsarg */
  char c;
  int i, k;
  char * local_p;

  while (largc > 1) /* If we are still within argument range */
    {
      if (argv [largvptr] != NULL) /* If argv is not null */
	{
	  if (argv [largvptr] [largvindex] != '\000') /* If argument is
							 not empty */
	    {
	      c = argv [largvptr] [largvindex];
	      local_p = argv [largvptr];
	      while (local_p [largvindex] == ' ')
		{
		  ++ largvindex;
		  if (local_p [largvindex] == '\000')
		    {
		      ++ largvptr;
		      -- largc;
		      largvindex = 0;
		      local_p = argv [largvptr];
		      /* If option not there, return */
		      if (largc == 1) return (NULL);
		    }
		}
	      if (c == '-') /* Found an option */
		{
		  return (NULL);
		}
	      i = 0;
	      for (k = largvindex;
		   ((local_p [k] != ' ')
		    && (local_p [k] != '\000'));)
		{
		  sec_optarg [i] = local_p [k];
		  ++ i; 
		  ++ k; 
		}
	      sec_optarg [i] = '\000';
	      /* Argument was successfully copied over */
	      largvindex = k;
	      return (sec_optarg);
	    }
	  else
	    {    
	      /* Skip to next arg */
	      ++ largvptr;
	      -- largc;
	      largvindex = 0;
	      if (largc == 1)
		return (NULL);
	      else
		local_p = argv [largvptr];
	      /* Throw away blank space and skip to next
		 argument if needed */
	      if (largc > 1)
		while (local_p [largvindex] == ' ')
		  {
		    ++ largvindex;
		    if (local_p [largvindex] == '\000')
		      {
			++ largvptr;
			-- largc;
			largvindex = 0;
			local_p = argv [largvptr];
		      }
		  }
	    }
	}
      else
	{
	  ++ largvptr;
	  -- largc;
	  largvindex = 0;
	  local_p = argv [largvptr];
	  /* If option not there, return */
	  if (largc == 1) return (NULL);
	}
      
    } /* Close loop that searches for legal options */

} /* fix_getsubsarg */
