#include "all.h"

//static int position;

/* Returns the integer number of non-blank records in the test sequence
   file */
int creat_tmp_vecfile (char from_file_name[], char to_file_name[])
{ /* get_num_vec */
  char line [3001] = "";
  char linebuf [3001] = "";
  int numvec = 0;
  int scnt = 0;
  FILE *fromfp, *tofp;

  fromfp = fopen(from_file_name, "r");
  tofp = fopen(to_file_name, "w"); //J.ZHANG

  while (fgets (line, 3000, fromfp) != NULL)
    {
      scnt = sscanf(line, "%s", linebuf);
      if (scnt > 0)
	{
	  numvec ++;
	  fprintf(tofp,"%s",line);//J.ZHANG
	}
    }
  fclose (tofp);//J.ZHANG
  fclose (fromfp); /* Close the file since we will be rereading it
			   from the beginning */
  /*  vectorsfile = fopen ("myvec.vectors", "rw");//J.ZHANG
  if (vectorsfile == NULL)
    {
      fprintf (resultsout,
	       "Cannot open %s file -- Aborted.\n", vectorsfile_name);
      exit(-1);
    }
  */
  return (numvec);
} /* get_num_vec */

int get_vec (char from_file_name[], int rpi, int from, int to)
{ /* read vectors from 'from' to 'to', including both 'from' & 'to' 
     from is greater or equal to 1, to can be aritrary positive integer */
  char line [3001] = "";
  char linebuf [3001] = "";
  int numvec = 0;
  int scnt = 0;
  FILE *fromfp;
  int i;
  
  if(tmpvecsize < (to-from+1) )
      resize_tmpvec(tmpvecsize, to-from+1, rpi);
  
  fromfp = fopen(from_file_name, "r");

  while (fgets (line, 3000, fromfp) != NULL)
    {
      scnt = sscanf(line, "%s", linebuf);
      if (scnt > 0)
	{
	  numvec ++;
	  if(numvec>=from && numvec<=to)
	    {
	      for(i=0;i<rpi;i++) 
		{
		  tmpvec[(numvec-from)*rpi+i] = linebuf[i];
if(VERBOSE)	  printf("%c",tmpvec[(numvec-from)*rpi+i]);
		}
if(VERBOSE)	  printf("\n");
	    }
	}
      if(numvec == to) break;
    }
  fclose (fromfp); /* Close the file since we will be rereading it
			   from the beginning */
  return (numvec-from+1);
} /* get_vec */

/* Returns the next bit from the test sequence file, going left to right,
   front to end 
   Returns -1 at end of file, otherwise returns ZERO, ONE, or X for each bit */
int get_testseq_bit (int num_rpi /* Number real circuit primary inputs */)
{ /* get_testseq_bit */
  static char line [3001];
  static char linebuf [3001];
  int scnt = 0;

  // fprintf(resultsout, "get_vec: position = %d\n", position);
  if ((position < 0) || (position >= num_rpi))
    {
      fgets (line, 3000, vectorsfile);
      if (line == NULL)
	{
	  //	  fprintf(resultsout, "line is NULL!!\n");
	  return (-1);
	}
      scnt = 0;
      while (scnt == 0)
	{
	  scnt = sscanf(line, "%s", linebuf);
          //fprintf(resultsout, "%s\n", line);
	}
      position = 0;
    }

  switch (linebuf [position])
    {
    case '0':
      ++ position;
      return '0'; //ZERO;
      break;
    case '1':
      ++ position;
      return '1'; //ONE;
      break;
    case 'X':
      ++ position;
      return 'X'; //X;
      break;
    default:
      fprintf (resultsout, "linebuf[position] = %c\n", linebuf[position]);
      fprintf (resultsout, "Illegal test vector value.\n");
      fflush (resultsout);
      exit (-1);
      break;
    }

} /* get_testseq_bit */

void reset_test_seq (char *vecfile_name)
{ /* reset_test_seq */

  fclose (vectorsfile); /* Close the file since we will be rereading it
			   from the beginning */
  vectorsfile = fopen (vecfile_name, "r");
  if (vectorsfile == NULL)
    {
      fprintf (resultsout,
	       "Cannot open %s file -- Aborted.\n", vecfile_name);
      exit(-1);
    }
  position = -1;

} /* reset_test_seq */


int append_vec(int **from_vec, char *vecfilename, int num_vec, int num_bits, int mustapp, int apd_ovwr/* 'append to the end' or 'overwrite from the beginning' */)
     //mustapp: if 'ture' then every vector is appended to the file
{
  int i,j,k;
  FILE *vecfile;

  if(num_vec > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-revise_vec()\n", 
	      num_vec, tmpvecsize); 
      exit(0);
    }
  
  k = 0;
  if(apd_ovwr == true) vecfile = fopen(vecfilename, "a");//append
  else vecfile = fopen(vecfilename, "w");//over_write

  for(i=0;i<num_vec;i++)
    {
      if((mustapp == true) || (removed[i]==false))
	{
	  for(j=0;j<num_bits;j++) fprintf(vecfile, "%c", (*from_vec)[i*num_bits+j]);
	  fprintf(vecfile, "\n");
	  k++;
	}
    }
  fflush(vecfile);
  fclose(vecfile);
  return k;
}

int cp_compacted_vec(int **from_array, int **to_array, int num_vec, 
		     int num_bits, int mustapp, int vecposition)
     //mustapp: if 'ture' then every vector is copied to the to_array
{
  int i,j,k;
  
  if(num_vec > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-cp_compacted_vec()\n", 
	      num_vec, tmpvecsize); 
      // exit(0);
    }
  
  k=vecposition;
  for(i=0;i<num_vec;i++)
    {
      if((mustapp == true) || (removed[i]==false))
	{
	  for(j=0;j<num_bits;j++)
	    { 
	    (*to_array)[k*num_bits+j] = (*from_array)[i*num_bits+j];
	    if((*from_array)[i*num_bits+j]!='1' && (*from_array)[i*num_bits+j]!='0' )
	      fprintf(resultsout, "%c!='0','1',k=%d,cp_compacted_vec\n", (*from_array)[i*num_bits+j],k+1);	  
	    }
	  k++;
	  if(k==tmpvecsize)
	    resize_tmpvec(tmpvecsize, tmpvecsize*2, num_bits);
	}
    }
  return k-vecposition;
}

void resize_tmpvec(int old_size, int new_size, int rpi)
{
  if(old_size < new_size)
    {
      tmpvecsize = new_size;
      tmpvec  = (int *)realloc(tmpvec, rpi*new_size*sizeof(int));
      tmpvec1 = (int *)realloc(tmpvec1,rpi*new_size*sizeof(int));
      tmpvec2 = (int *)realloc(tmpvec2,rpi*new_size*sizeof(int));
      removed = (int *)realloc(removed, new_size*sizeof(int));
      removed_tmp = (int *)realloc(removed, new_size*sizeof(int));
      if(tmpvec == NULL || tmpvec1 == NULL || removed == NULL || removed_tmp == NULL || tmpvec2 == NULL)
	{
	  fprintf(resultsout, "memory realloc wrong!!--resize_tmpvec()\n");
	  fflush(resultsout);
	  exit(0);
	}
    }
}


