#include "Include/all.h"
#include "fix_getopt.c"

void setoptions (int argc, char *argv[])
{ /* setoptions */
  int i;
  char c;
  int largc = argc;
  char **largv = argv;
  extern int optind;

  resultsout = stdout;
  errfile = stdout;
  use_timeflag = false;
  Hsize_set = SG_set = bit_ptb_set = noisyM_set = phase_set = -1;
  exp_iter_set = -1;
  HD_Hsize_set = HD_cutoff_set = -1;
  Ptb_period_set = fs_shift_set = -1;
  
  /* Process each argument */
  if (argc < 3)
    {
      print_usage();
      exit(1);
    }      

  while ((c = fix_getopt (argc, argv, "I:J:K:L:M:N:O:P:Q:S:T:U:V:Wi:j:k:l:m:n:o:p:q:s:t:u:v:w")) != -1)
    {
      switch (c)
	{
	case 'i':
	case 'I':
	  strcpy (circuit_name, fix_optarg);
	  i = FindExtender (circuit_name);
	  if (i != NOTFOUND)
	    circuit_name [i] = NullChar;
	  break;
	case 'j':
	case 'J':
	  Hsize_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       Hsize_set = Hsize_set*10+fix_optarg[i]-48;
	  //printf("-Jj:%s\n",fix_optarg);
	  break;
	case 'k':
	case 'K':
	  bit_ptb_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       bit_ptb_set = bit_ptb_set*10+fix_optarg[i]-48;
	  //printf("-Kk:%s\n",fix_optarg);
	  break;
	case 'l':
	case 'L':
	  noisyM_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       noisyM_set = noisyM_set*10+fix_optarg[i]-48;
	  //printf("-Ll:%s\n",fix_optarg);
	  break;
	case 'm':
	case 'M':
	  phase_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       phase_set = phase_set*10+fix_optarg[i]-48;
	  //printf("-Mm:%s\n",fix_optarg);
	  break;
	case 'n':
	case 'N':
	  SG_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       SG_set = SG_set*10+fix_optarg[i]-48;
	  //printf("-Nn:%s\n",fix_optarg);
	  break;
	case 'o':
	case 'O':
	  user_resultsfile = true;
	  if (fix_optarg [0] != nullchar)
	    {
	      strcpy (resultsfile_name, fix_optarg);
	    }
	  break;
	case 'p':
	case 'P':
	  Ptb_period_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	      Ptb_period_set = Ptb_period_set*10+fix_optarg[i]-48;
	case 'q':
	case 'Q':
	  fs_shift_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	      fs_shift_set = fs_shift_set*10+fix_optarg[i]-48;
	case 's':
	case 'S':
	  exp_iter_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       exp_iter_set = exp_iter_set*10+fix_optarg[i]-48;
	  //printf("-Ss:%s\n",fix_optarg);
	  break;
	  //to get the time flag -J. Zhang
	case 't':
	case 'T':
	  if (fix_optarg [0] != nullchar)
	    {
	      strcpy (time_flagg, fix_optarg);
	      use_timeflag = true;
	    }
	  break;
	case 'u':
	case 'U':
	  HD_Hsize_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       HD_Hsize_set = HD_Hsize_set*10+fix_optarg[i]-48;
	  //printf("-Uu:%s\n",fix_optarg);
	  break;
	case 'v':
	case 'V':
	  HD_cutoff_set = 0;
	  for(i=0;i<strlen(fix_optarg);i++)
	    if(isdigit(fix_optarg[i])) 
	       HD_cutoff_set = HD_cutoff_set*10+fix_optarg[i]-48;
	  //printf("-Vv:%s\n",fix_optarg);
	  break;
	case 'w':
	case 'W':
	  VERBOSE = TRUE;
	  //printf("verbose = %d\n",VERBOSE);
	  break;
	case '?':
	default:
	  printf ("SpectralATPG: Illegal option %c.\n", c);
	  exit(-99);
	  break;
	}
    }

  if (user_resultsfile == false)
    {
      sprintf (resultsfile_name, "%s%s", circuit_name, SUF_RESULTS);
    }
  resultsout = fopen(resultsfile_name, "w+");
  errfile = resultsout;

  sprintf (sch_file_name,   "%s%s", circuit_name, SUF_SCHE);
  sprintf (fault_file_name, "%s%s", circuit_name, SUF_FAULT);
  sprintf (vectorsfile_name, "%s%s", circuit_name, SUF_VECTOR);

  /* Print the command line for reference */
  for(i=0;i<largc;++i)
    {
      fprintf(resultsout, "%s ", largv[i]);
    }
  fprintf(resultsout, "\n");

  resultsfile_head (resultsout);
} /* setoptions */

