#include "all.h"

/*************************************************************************/
/* Function:                                                             */
/*   Generate random test patterns					 */
/* Input:								 */
/*   vectorfile - a file pointer to the test pattern vector file	 */
/*   num_pi - number of primary inputs in the circuit                    */
/* Return:								 */
/*   none								 */
/*************************************************************************/

void rpg (char * ckt_name, int num_pi, int maxvecnum)
     // if maxvecnum == 0, using the hard-coded vec num
{ /* rpg */
  int  i, j;
  long ran_num;
  char vector_file_name [128];
  FILE * vector_file;
  long int* labeling_word;
  int vect_count;
  int limit;

  printf ("circuit = %s, no pi = %d\n", ckt_name, num_pi); 
  sprintf (vector_file_name, "%s.vectors", ckt_name);
  vector_file = fopen (vector_file_name, "w");
  labeling_word = (long int *) calloc (4 * (num_pi) + 1, sizeof(long int));
  if (strcmp (ckt_name, "s382") == 0)
    limit = 763;
  else if (strcmp (ckt_name, "s400") == 0)
    limit = 716;
  else if (strcmp (ckt_name, "s713") == 0)
    limit = 108;
  else if (strcmp (ckt_name, "s1196") == 0)
    limit = 244;
  else if (strcmp (ckt_name, "s1238") == 0)
    limit = 255;
  else if (strcmp (ckt_name, "s1423") == 0)
    limit = 1148;
  else if (strcmp (ckt_name, "s1488") == 0)
    limit = 681;
  else if (strcmp (ckt_name, "s1494") == 0)
    limit = 516;
  else if (strcmp (ckt_name, "s5378") == 0)
    limit = 861;
  else
    {
      printf("Circuit is not in the giani list!.\n");
      // exit (-1);
    }
  //this is just for tmp use -J. Zhang
  if(maxvecnum != 0) limit = maxvecnum;
  
  for (vect_count = 0; vect_count < limit; ) 
    {
      for (i=1; i <= num_pi; i++)
	{
	  ran_num = random();
	  labeling_word [i] = ran_num;
	}
      for (j=1; j <=32 ; ++j)
	{
	    if (vect_count < limit)
	      {
		for (i = 1; i <= num_pi; i++)
		  fprintf (vector_file, "%ld",
			   random()%2);
		// (labeling_word [i] >> (32 - j)) & 0x00000001);
		fprintf (vector_file, "\n");
		++ vect_count;
	      } 
	    else
	      {
		fclose (vector_file);
		free (labeling_word);
		return;
	      }
	}
    }
  fclose (vector_file);
  free (labeling_word);
  return;
} /* rpg */
