/****************************************************************************
  sesterror.c
****************************************************************************/
#include "all.h"

void fprintflush (FILE *file, char *message)
{ /* fprintflush */
  fprintf(file, message);
  fflush(file);
} /* fprintflush */

void print_usage (void)
{ /* print_usage */
      
  fprintf (errfile, "Usage: spectralatpg.sun4 [options]\n");
  fprintf (errfile, "Options (can be either upper or lower case):\n");
  fprintf (errfile, "  -I or i <filename> Name of input file (leave off extender).\n");
  fprintf (errfile,
	   "  -J or j Set the size of the Hadamard matrix to be used (Default:16).\n");
  fprintf (errfile,
	   "  -K or k Set the maximum number of iterations of the Bit-Perturbation algorithm (default: 30).\n");
  fprintf (errfile,
	   "  -L or l Set the maximum number of iterations of the Noisy Matrix algorithm (default: 0).\n");
  fprintf (errfile,
	   "  -M or m Set the maximum number of iterations of the Phase-Perturbation algorithm (default: 0).\n");
  fprintf (errfile,
	   "  -N or n Set the maximum number of iterations of the SG Algorithms 2 (default: 0).\n");
  fprintf (errfile,
	   "  -O or o <filename> Specify results file name (defaults to stdout).\n");
  fprintf (errfile,
	   "  -P or p Set a fixed period for random Bit-Perturbation (default: in turn taking the following values: 2, 4, 6, 8, 10, 12, 14, 16).\n");
  fprintf (errfile,
	   "  -Q or q Set a fixed number of phase-shifting cycles for Phase-Perturbation (default: in turn taking the following values: 2, 4, 6, 8, 10, 12, 14, 16).\n");
  fprintf (errfile,
	   "  -S or s Set the maximum holding time of vectors (default: 64).\n");
  fprintf (errfile,
	   "  -T or t <timeflag> Timeflag to differentiate output file names.\n");
  fprintf (errfile,
	   "  -U or u Set the size of the BIST Hadamard matrix (Default:8).\n");
  fprintf (errfile,
	   "  -V or v Set the cutoff value of the BIST Hadamard matrix-filtering operation (Default:4).\n");
  fprintf (errfile,
	   "  -W or w Produce Verbose output in the results file.\n");
  fprintf (errfile,
	   "The program needs a <filename>.faults file with the fault list.\n");
  fprintf (errfile,
	   "The above four methods are used in the following order: \n     1) Bit-Perturbation\n     2) Noisy Matrix\n     3) Phase-Perturbation\n     4) SG Algorithm 2\n");
  return;
} /* print_usage */


