#include "all.h"

int      h16[16][16]= {{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		       { 1,-1, 1,-1, 1,-1, 1,-1, 1,-1, 1,-1, 1,-1, 1,-1},
		       { 1, 1,-1,-1, 1, 1,-1,-1, 1, 1,-1,-1, 1, 1,-1,-1},
		       { 1,-1,-1, 1, 1,-1,-1, 1, 1,-1,-1, 1, 1,-1,-1, 1},
		       { 1, 1, 1, 1,-1,-1,-1,-1, 1, 1, 1, 1,-1,-1,-1,-1},
		       { 1,-1, 1,-1,-1, 1,-1, 1, 1,-1, 1,-1,-1, 1,-1, 1},
		       { 1, 1,-1,-1,-1,-1, 1, 1, 1, 1,-1,-1,-1,-1, 1, 1},
		       { 1,-1,-1, 1,-1, 1, 1,-1, 1,-1,-1, 1,-1, 1, 1,-1},
                       { 1, 1, 1, 1, 1, 1, 1, 1,-1,-1,-1,-1,-1,-1,-1,-1},
		       { 1,-1, 1,-1, 1,-1, 1,-1,-1, 1,-1, 1,-1, 1,-1, 1},
		       { 1, 1,-1,-1, 1, 1,-1,-1,-1,-1, 1, 1,-1,-1, 1, 1},
		       { 1,-1,-1, 1, 1,-1,-1, 1,-1, 1, 1,-1,-1, 1, 1,-1},
		       { 1, 1, 1, 1,-1,-1,-1,-1,-1,-1,-1,-1, 1, 1, 1, 1},
		       { 1,-1, 1,-1,-1, 1,-1, 1,-1, 1,-1, 1, 1,-1, 1,-1},
		       { 1, 1,-1,-1,-1,-1, 1, 1,-1,-1, 1, 1, 1, 1,-1,-1},
		       { 1,-1,-1, 1,-1, 1, 1,-1,-1, 1, 1,-1, 1,-1,-1, 1}};
int init_sg(int num_vec, int num_bits)
{
  int i, j, k;
  if( sg_malloc == false)
    {
      probability = (int **)malloc((num_vec)*sizeof(int *));
      history     = (int **)malloc((num_vec)*sizeof(int *));
      vect1       = (int **)malloc((num_vec)*sizeof(int *));
      vect2       = (int **)malloc((num_vec)*sizeof(int *));
      spectre     = (int **)malloc((num_vec)*sizeof(int *));
      spectre1    = (int **)malloc((num_vec)*sizeof(int *));
      spectre2    = (int **)malloc((num_vec)*sizeof(int *));
      vect_hist   =(int ***)malloc((num_vec)*sizeof(int **));
      vect_pt     = (int )malloc(sizeof(int));
      
      for(i=0;i<num_vec;i++)
	{
	  probability[i] = (int *)malloc((num_bits)*sizeof(int ));
	  history[i]     = (int *)malloc((num_bits)*sizeof(int ));
	  vect1[i]       = (int *)malloc((num_bits)*sizeof(int ));
	  vect2[i]       = (int *)malloc((num_bits)*sizeof(int ));
	  spectre[i]     = (int *)malloc((num_bits)*sizeof(int ));
	  spectre1[i]    = (int *)malloc((num_bits)*sizeof(int ));
	  spectre2[i]    = (int *)malloc((num_bits)*sizeof(int ));
	  vect_hist[i]   =(int **)malloc((num_bits)*sizeof(int *));
	  for(j=0;j<num_bits;j++)
	    vect_hist[i][j] = (int *)malloc((MAX_HIST)*sizeof(int *));
	} 
      sg_malloc = true; 
    }
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	probability[i][j] = MAX_HIST/2;
	history[i][j]     = MAX_HIST/2;
	for(k=0;k<MAX_HIST;k++)
	  vect_hist[i][j][k] = k%2; 
      }
  vect_pt = 0;
  return 1;
}

void update_history(int i, int j, int k)
/*
  i, j are the indexes for the vect_hist
  k is the bit value generated in select_individual
*/

{
  if(vect_hist[i][j][vect_pt] == 1 && k == 0 )
    history[i][j]--;
  else if(vect_hist[i][j][vect_pt] == 0 && k == 1 )
    history[i][j]++;
  vect_hist[i][j][vect_pt] = k;
  vect_pt = (vect_pt+1)%MAX_HIST;
}

void select_best(int num_vec, int num_bits)
{
  int i, j, k;

  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	k = probability[i][j];

	if(k > (MAX_HIST/2)) vect1[i][j] = 1;
	else if(k == (MAX_HIST/2) && rand()%2 == 1) vect1[i][j] = 1;//prob=0.5
	else vect1[i][j] = 0;

	spectre1[i][j] = k - MAX_HIST/2;

      }
}

void select_individual(int num_vec, int num_bits)
/*
   The selected two individuals are saved in vect1 and vect2;
   The update_history updates the individual history accordingly then.
*/
{
  int i, j, k, m;
  //  static int vect1[NUM_VEC][NUM_BITS], vect2[NUM_VEC][NUM_BITS];//need to declared somewhere else.

  m = (MAX_HIST/10);

  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	//k = probability[i][j]-history[i][j]+rand()%(m*2+1)-m;
	k = rand()%33-16;
	//the prob to generate next bit with randomness 
	if(k > (0)) vect1[i][j] = 1;
	else if(k == (0) && rand()%2 == 1) vect1[i][j] = 1;//prob=0.5
	else vect1[i][j] = 0;

	spectre1[i][j] = k;// - MAX_HIST/2;

	update_history(i, j, vect1[i][j]);
	
	//k = probability[i][j]-history[i][j]+rand()%(m*2+1)-m;
	k = rand()%33-16;
	if(k > 0) vect2[i][j] = 1;
	else if(k == 0 && rand()%2 == 1) vect2[i][j] = 1;
	else vect2[i][j] = 0;

	spectre2[i][j] = k;// - MAX_HIST/2;
	
	update_history(i, j, vect2[i][j]);
      } 
}

void evolve(int num_vec, int num_bits, int winner)
     /*
       If winner = 1, vect1 wins.  winner = 2, vect2 wins.
     */
{
  int i, j, k;
  
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	k = vect1[i][j] - vect2[i][j];
	k = k*(3-2*winner);//a little bit tricky
	probability[i][j] = (probability[i][j]+k*EVLV_STEP);//%MAX_HIST;
      }
}

void random_perturb(int num_vec, int num_bits)
{
  int i, j;
  
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	probability[i][j] += rand()%2;//(MAX_HIST/5+1)-MAX_HIST/10;
      }
}

void initial_prob(int *array, int num_vec, int num_bits, int startposition)
{
  int i, j;

  /*This code bias the initial prob towards the array's initial value*/  
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	if(array[(i+startposition)*num_bits+j] == '1')
	  probability[i][j] = MAX_HIST*3/4;
	else 
	  probability[i][j] = MAX_HIST/4;
      }
}

void selfish_gene_bit(int num_vec, int num_bits, int *tmpvec, int tmpvec_len)
{
  int tested1=0, tested2=0;
  int iter, totaliter = 100;
  int startposition=0, i;
  
  for(i=0, startposition = 0;i<(tmpvec_len/num_vec); i++, startposition = i*num_vec)
    {
      init_sg(num_vec, num_bits);
      initial_prob(tmpvec, num_vec, num_bits, startposition);
      
      for(iter=0;iter<totaliter; iter++)
	{
	  select_individual(num_vec, num_bits);
	  revise_vec(num_vec, num_bits, vect1, tmpvec, startposition);
	  tested1 = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
			   USEARRAY, resultsout, circuit, faultlist,
			   UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
			   0, EARLY_STOP);
	  revise_vec(num_vec, num_bits, vect2, tmpvec, startposition);
	  tested2 = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
			   USEARRAY, resultsout, circuit, faultlist,
		       UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
			   0, EARLY_STOP);
	  if(tested1 == tested2) random_perturb(num_vec, num_bits);
	  else evolve(num_vec, num_bits, (tested1 > tested2) ? 1:2 );
	  if(iter%5 == 0)
	    printf("SG[%d]--tested=%d\n",iter, (tested1>tested2)? tested1:tested2);
	}
  
      select_best(num_vec, num_bits);//best is stored in vect1
      revise_vec(num_vec, num_bits, vect1, tmpvec, startposition);
    }
}

void get_spectral_prob(int *array, int num_vec, int num_bits, int startvec)
{
  int i, j;
  int tmpVect16[16][1],coef116[1][16];
  int row; //the first column to be written in with the expanded vectors

   /*copy the vector bits to spectre*/  
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	spectre[i][j] = array[(i+startvec)*num_bits+j]-'0';
      }
  
  /*extract the spectre coef and store in spectre*/
  for(row=0;row<(num_vec/16);row++)
    for(i=0;i<num_bits;i++)
      {
	for(j=0;j<16;j++)
	  {
	    tmpVect16[j][0]=2*spectre[row*16+j][i]-1;//change 0 to -1
	  }
	MatrMult(16,16,1,(int*)h16,(int*)tmpVect16,(int*)coef116);//get corelation coef
	for(j=0;j<16;j++) 
	  {
	    spectre[row*16+j][i]= coef116[0][j];
	  }
      }//for(i  
  for(i=0;i<num_vec;i++)
    for(j=0;j<num_bits;j++)
      {
	probability[i][j] = spectre[i][j] + MAX_HIST/2;
      }  
}

void creat_spectre_vec( int num_vec, int num_bits )
{
  int i, j;
  int tmpVect16[16][1],coef116[1][16];
  int row; //the first column to be written in with the expanded vectors

  for(row=0;row<(num_vec/16);row++)
    for(i=0;i<num_bits;i++)
      {
	for(j=0;j<16;j++)
	  {
	    coef116[0][j] = spectre1[j][i];
	  }
	MatrMult(1,16,16,(int*)coef116,(int*)h16,(int*)tmpVect16);
	for(j=0;j<16;j++) 
	  {
	    if(tmpVect16[j][0]==0) spectre1[j][i] = rand()%2;
	    else 
	      spectre1[j][i] = (tmpVect16[j][0]>0)? 1:0;
	  }
      }//for(i

  for(row=0;row<(num_vec/16);row++)
    for(i=0;i<num_bits;i++)
      {
	for(j=0;j<16;j++)
	  {
	    coef116[0][j] = spectre2[j][i];
	  }
	MatrMult(1,16,16,(int*)coef116,(int*)h16,(int*)tmpVect16);
	for(j=0;j<16;j++) 
	  {
	    if(tmpVect16[j][0]==0) spectre2[j][i] = rand()%2;
	    else 
	      spectre2[j][i] = (tmpVect16[j][0]>0)? 1:0;
	  }
      }//for(i
}

void selfish_gene_spectral(int num_vec, int num_bits, int *tmpvec, int tmpvec_len,
			   int totaliter, int step)
{
  int tested1=0, tested2=0, tested_best=0;
  int iter;// totaliter = 50;
  int i, startposition=0;

  for(i=0, startposition = 0;i<(tmpvec_len/num_vec); i += step, startposition = i*num_vec)
    {
      init_sg(num_vec, num_bits);
      /*set the prob pool according to the initial spectre*/
      get_spectral_prob(tmpvec, num_vec, num_bits, startposition);
      /*establish the base line of evolution*/
      tested_best = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
			   USEARRAY, resultsout, circuit, faultlist,
			   UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
			   0, EARLY_STOP);

      backup_vec(num_vec, num_bits, spectre, tmpvec, startposition);

      for(iter=0;iter<totaliter; iter++)
	{
	  select_individual(num_vec, num_bits);
	  creat_spectre_vec(num_vec, num_bits);
	  revise_vec(num_vec, num_bits, spectre1, tmpvec, startposition);
	  tested1 = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
			   USEARRAY, resultsout, circuit, faultlist,
			   UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
			   0, EARLY_STOP);
	  revise_vec(num_vec, num_bits, spectre2, tmpvec, startposition);
	  tested2 = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
			   USEARRAY, resultsout, circuit, faultlist,




			   UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
			   NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
			   0, EARLY_STOP);
	  if(tested1 == tested2) random_perturb(num_vec, num_bits);
	  else evolve(num_vec, num_bits, (tested1 > tested2) ? 1:2 );
	  if (tested1 > tested2 && tested1 > tested_best ) 
	    {
	      cp_vec(num_vec, num_bits, spectre1, spectre);
	      tested_best = tested1;
	    }
	  else if(tested2 > tested1 && tested2 > tested_best ) 
	    {
	      cp_vec(num_vec, num_bits, spectre2, spectre);
	      tested_best = tested2;
	    }
	  if(iter%5 == 0)
	    printf("SG[%d]--tested=%d\n",iter, (tested1>tested2)? tested1:tested2);
	}
      
      select_best(num_vec, num_bits);//best spectre coefs are stored in spectre1
      creat_spectre_vec(num_vec, num_bits);
      revise_vec(num_vec, num_bits, spectre1, tmpvec, startposition);
      /*test to see if it gives better fault coverage*/
      tested1 = sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
		       USEARRAY, resultsout, circuit, faultlist,
		       UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
		       NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
		       0, EARLY_STOP);
      /*if not, restore the best one ever stored */
      if(tested1 < tested_best)
	revise_vec(num_vec, num_bits, spectre, tmpvec, startposition);
      tested_best =
	sfsim ("tmpvec.vectors", tmpvec, num_bits, tmpvec_len,
	       USEARRAY, resultsout, circuit, faultlist,
	       UNDETECTEDF, sfsimdebug, NCREAT_FLIST, 0,
	       NUPDATE_STATE, NUPDATE_FAULT, UNINITIAL_FAULT, false,
	       0, EARLY_STOP);
      //fprintf(resultsout, "SG: start vec = %d, final tested = %d \n", startposition,tested_best); 
      printf("SG: start vec = %d, best tested=%d\n",startposition, tested_best);
    }
}

void revise_vec(int num_vec, int num_bits,int **vect, int *tmpvec, int startposition)
{
  int i, j;
  if(num_vec+startposition > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-revise_vec()\n", 
	      num_vec, tmpvecsize); 
      exit(0);
    }
  for(i=0;i<num_vec;i++)
    {
    for(j=0;j<num_bits;j++)
      {
	tmpvec[(i+startposition)*num_bits+j] = vect[i][j] + '0';
	//printf("%c", tmpvec[(i+startposition)*num_bits+j]);
      }
    // printf("\n");
    }
}

void backup_vec(int num_vec, int num_bits,int **vect, int *tmpvec, int startposition)
{
  int i, j;
  if(num_vec+startposition > tmpvecsize)
    {
      fprintf(resultsout, 
	      "num_vec=%d > tmpvecsize=%d. Wrong!!-revise_vec()\n", 
	      num_vec, tmpvecsize); 
      exit(0);
    }
  for(i=0;i<num_vec;i++)
    {
    for(j=0;j<num_bits;j++)
      {
	vect[i][j] = tmpvec[(i+startposition)*num_bits+j] - '0';
	//printf("%c", tmpvec[(i+startposition)*num_bits+j]);
      }
    // printf("\n");
    }
}

void cp_vec(int num_vec, int num_bits,int **from_vect, int **to_vect)
{
  int i, j;
  for(i=0;i<num_vec;i++)
    {
      for(j=0;j<num_bits;j++)
	{
	  to_vect[i][j] = from_vect[i][j];
	  //printf("%c", tmpvec[(i+startposition)*num_bits+j]);
	}
      // printf("\n");
    }
}



